
package de.ivu.elect.business.wahlbeteiligung.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.wahlbeteiligung.entity.Wahlbeteiligung;

@RequestScoped
@Named(WahlbeteiligungConversationSelect.COMPONENT_NAME)
public class WahlbeteiligungConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlbeteiligungConversationSelect";

  @Inject
  protected transient WahlbeteiligungExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(WahlbeteiligungConversationStore.class)
  protected transient WahlbeteiligungConversationStore conversationStore;

  public WahlbeteiligungConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public Wahlbeteiligung getEntity() {
    return getEntityInternal();
  }

  private Wahlbeteiligung getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(Wahlbeteiligung entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(Wahlbeteiligung entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected Wahlbeteiligung attach(Wahlbeteiligung entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected Wahlbeteiligung attach( de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
